program DISP4I30;
uses dos,CRT;

{$I 4I30LOW}
{$I hprint}
{$I hexread}

type

CounterStuffRec =

record
  Count : longint;
  OldCount : longint;
  Time : longint;
  OldTime : longint;
  CountsPerSec : longint;
end;

var

CounterStuff : array [0..3] of CounterStuffRec;
procedure BarfOut(s:string);
begin
  writeln;
  writeln(chr(7),s);
  writeln;
  halt(2);
end;

procedure Usage;
begin
  writeln;
  writeln('Usage: 4I30DISP PPP');
  writeln;
  writeln('Where PPP is the hexadecimal 4I30 base address');
  writeln;
  writeln('Function: Testing 4I30 card');
  halt(2);
end;

procedure GetParms;
begin
  If ParamCount < 1 then Usage;
  if not HexWordRead(ParamStr(1),I30BasePort)  then BarfOut('Undecipherable 4I30 address ');
  if I30BasePort < $100  then BarfOut('Out of range 4I30 address ');
  if I30BasePort > $3F8  then BarfOut('Out of range 4I30 address ');
end;

procedure ReadAll;
var
cnum : byte;
deltac : real;
deltat : real;
realrate : real;
begin
  for cnum := 0 to 3 do
  begin
    with CounterStuff[cnum] do
    begin
      OldCount := Count;
      OldTime := Time;
      ReadCounterAndDelta(cnum,Count,Time);
      if Time-OldTime <> 0 then
      begin
        deltac := abs(Count-OldCount);
        deltat := abs(Time - OldTime);
        realrate := deltac/deltat * RefRate;
        CountsPerSec := round(realrate);
      end
      else CountsPerSec := -1;
    end;
  end;
end;

procedure ShowAll;
var cnum : byte;
begin
  for cnum := 0 to 3 do
  begin
    with CounterStuff[cnum] do
    begin
      GoToXY(1,(cnum * 2)+3);
      write(cnum:1,'      ',Count:10,'       ',CountsPerSec:7,'    ');
    end;
  end;
end;


begin
  GetParms;
  Init4I30;
  ReadAll;
  Delay(100);
  ClrScr;
  writeln('Counter     Count     Counts Per Second');
  while not keypressed do
  begin
    ReadAll;
    ShowAll;
    Delay(100); { This delay determines our sample rate }
                { but does not alter our cps accuracy   }
                { other than changing the resolution    }
                { of our delta T and delta C            }
  end;
end.