program Read4I30;
uses dos,CRT;
{$I 4I30LOW}
{$I hprint}
{$I hexread}
var
deci : boolean;
oldcount : longint;
count: longint;
chan : byte;

procedure BarfOut(s:string);
begin
  writeln;
  writeln(chr(7),s);
  writeln;
  halt(2);
end;

procedure Usage;
begin
  writeln;
  writeln('Usage: 4I30READ PPP [CHAN] [D]');
  writeln;
  writeln('Where PPP is the hexadecimal 4I30 base address');
  writeln('      CHAN is the optional channel number (default=0)');
  writeln('      D means to print results in decimal (default=Hex)');
  writeln;
  writeln('Function: Testing 4I30 counters');
  halt(2);
end;

procedure GetParms;
var
ps : string;
retcode : integer;
begin
  deci := false;
  chan := 0;
  If ParamCount < 1 then Usage;
  if not HexWordRead(ParamStr(1),I30BasePort)  then BarfOut('Undecipherable 4I30 address ');
  if I30BasePort < $100  then BarfOut('Out of range 4I30 address ');
  if I30BasePort > $3F8  then BarfOut('Out of range 4I30 address ');
  if ParamCount > 1 then
  begin
    ps := ParamStr(2);
    val(ps,chan,retcode);
    chan := chan and ChSelMask;
    ps := ParamStr(3);
    if upcase(ps[1]) = 'D' then deci := true else deci := false;
  end;
end;

procedure ReadLoop;
begin
  Init4I30;
  while not keypressed do
  begin
    if deci then
    begin
      count := ReadCounter(chan);
      write(Chr(13),count:12,'  ',count-oldcount:4);
      oldcount := count;
    end
    else
    begin
      write(Chr(13));
      count := ReadCounter(chan);
      HexPrint(count,8);
      write('  ');
      HexPrint(count-oldcount,5);
      oldcount := count;
    end;
  end;
end;

begin
  GetParms;
  ReadLoop;
end.
